Linux ip-172-26-5-244 6.1.0-28-cloud-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.119-1 (2024-11-22) x86_64
Apache
: 172.26.5.244 | : 216.73.216.21
Cant Read [ /etc/named.conf ]
8.3.14
daemon
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
[
66.89
KB
-rwxr-xr-x
aa-enabled
18.23
KB
-rwxr-xr-x
aa-exec
18.23
KB
-rwxr-xr-x
aa-features-abi
18.23
KB
-rwxr-xr-x
addpart
30.31
KB
-rwxr-xr-x
addr2line
23.14
KB
-rwxr-xr-x
apropos
51.29
KB
-rwxr-xr-x
apt
18.31
KB
-rwxr-xr-x
apt-cache
86.38
KB
-rwxr-xr-x
apt-cdrom
22.38
KB
-rwxr-xr-x
apt-config
26.31
KB
-rwxr-xr-x
apt-extracttemplates
22.39
KB
-rwxr-xr-x
apt-ftparchive
270.39
KB
-rwxr-xr-x
apt-get
50.38
KB
-rwxr-xr-x
apt-key
27.32
KB
-rwxr-xr-x
apt-listchanges
11.96
KB
-rwxr-xr-x
apt-mark
58.38
KB
-rwxr-xr-x
apt-sortpkgs
38.32
KB
-rwxr-xr-x
ar
51.17
KB
-rwxr-xr-x
arch
42.86
KB
-rwxr-xr-x
as
897.41
KB
-rwxr-xr-x
at
58.37
KB
-rwsr-sr-x
atq
58.37
KB
-rwsr-sr-x
atrm
58.37
KB
-rwsr-sr-x
autoconf
14.85
KB
-rwxr-xr-x
autoheader
8.82
KB
-rwxr-xr-x
autom4te
32.69
KB
-rwxr-xr-x
autoreconf
26.3
KB
-rwxr-xr-x
autoscan
16.77
KB
-rwxr-xr-x
autoupdate
33.22
KB
-rwxr-xr-x
awk
154.66
KB
-rwxr-xr-x
aws
815
B
-rwxr-xr-x
b2sum
58.98
KB
-rwxr-xr-x
base32
46.89
KB
-rwxr-xr-x
base64
46.89
KB
-rwxr-xr-x
basename
42.83
KB
-rwxr-xr-x
basenc
54.89
KB
-rwxr-xr-x
bash
1.21
MB
-rwxr-xr-x
bashbug
6.7
KB
-rwxr-xr-x
batch
152
B
-rwxr-xr-x
bunzip2
38.3
KB
-rwxr-xr-x
busctl
90.5
KB
-rwxr-xr-x
bzcat
38.3
KB
-rwxr-xr-x
bzcmp
2.17
KB
-rwxr-xr-x
bzdiff
2.17
KB
-rwxr-xr-x
bzegrep
3.69
KB
-rwxr-xr-x
bzexe
4.78
KB
-rwxr-xr-x
bzfgrep
3.69
KB
-rwxr-xr-x
bzgrep
3.69
KB
-rwxr-xr-x
bzip2
38.3
KB
-rwxr-xr-x
bzip2recover
14.23
KB
-rwxr-xr-x
bzless
1.27
KB
-rwxr-xr-x
bzmore
1.27
KB
-rwxr-xr-x
c++
1.25
MB
-rwxr-xr-x
c++filt
18.51
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.73
KB
-rwxr-xr-x
cal
36.84
KB
-rwxr-xr-x
captoinfo
90.34
KB
-rwxr-xr-x
cat
42.98
KB
-rwxr-xr-x
catman
42.77
KB
-rwxr-xr-x
cc
1.24
MB
-rwxr-xr-x
chacl
14.23
KB
-rwxr-xr-x
chage
78.49
KB
-rwxr-sr-x
chardet
221
B
-rwxr-xr-x
chardetect
221
B
-rwxr-xr-x
chattr
14.24
KB
-rwxr-xr-x
chcon
67.11
KB
-rwxr-xr-x
chfn
61.2
KB
-rwsr-xr-x
chgrp
67.05
KB
-rwxr-xr-x
chmod
62.98
KB
-rwxr-xr-x
choom
54.31
KB
-rwxr-xr-x
chown
71.05
KB
-rwxr-xr-x
chrt
66.31
KB
-rwxr-xr-x
chsh
51.64
KB
-rwsr-xr-x
cksum
139.05
KB
-rwxr-xr-x
clear
14.24
KB
-rwxr-xr-x
clear_console
14.15
KB
-rwxr-xr-x
cloud-id
972
B
-rwxr-xr-x
cloud-init
976
B
-rwxr-xr-x
cloud-init-per
2.06
KB
-rwxr-xr-x
cloud-localds
7.21
KB
-rwxr-xr-x
cmp
50.95
KB
-rwxr-xr-x
col
34.31
KB
-rwxr-xr-x
colcrt
14.31
KB
-rwxr-xr-x
colrm
30.31
KB
-rwxr-xr-x
column
54.31
KB
-rwxr-xr-x
comm
46.92
KB
-rwxr-xr-x
corelist
15.01
KB
-rwxr-xr-x
cp
147.61
KB
-rwxr-xr-x
cpan
8.16
KB
-rwxr-xr-x
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
cpio
158.56
KB
-rwxr-xr-x
cpp
1.24
MB
-rwxr-xr-x
cpp-12
1.24
MB
-rwxr-xr-x
crontab
42.63
KB
-rwxr-sr-x
csplit
119.17
KB
-rwxr-xr-x
ctstat
26.59
KB
-rwxr-xr-x
curl
274.22
KB
-rwxr-xr-x
cut
46.98
KB
-rwxr-xr-x
cvtsudoers
337.19
KB
-rwxr-xr-x
dash
122.7
KB
-rwxr-xr-x
date
119.05
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
dbus-daemon
238.56
KB
-rwxr-xr-x
dbus-monitor
26.23
KB
-rwxr-xr-x
dbus-run-session
14.23
KB
-rwxr-xr-x
dbus-send
30.22
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.22
KB
-rwxr-xr-x
dbus-uuidgen
14.22
KB
-rwxr-xr-x
dd
87.15
KB
-rwxr-xr-x
deb-systemd-helper
23.79
KB
-rwxr-xr-x
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-set-selections
2.92
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debianbts
217
B
-rwxr-xr-x
delpart
30.31
KB
-rwxr-xr-x
delv
41.3
KB
-rwxr-xr-x
devdump
180.17
KB
-rwxr-xr-x
df
99.8
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_bash-completion
4.31
KB
-rwxr-xr-x
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
diff
151.58
KB
-rwxr-xr-x
diff3
67.14
KB
-rwxr-xr-x
dig
142.77
KB
-rwxr-xr-x
dir
147.8
KB
-rwxr-xr-x
dircolors
50.92
KB
-rwxr-xr-x
dirname
38.83
KB
-rwxr-xr-x
dirsplit
16.74
KB
-rwxr-xr-x
dmesg
86.58
KB
-rwxr-xr-x
dnsdomainname
22.15
KB
-rwxr-xr-x
dnstap-read
18.33
KB
-rwxr-xr-x
docutils
960
B
-rwxr-xr-x
domainname
22.15
KB
-rwxr-xr-x
dpkg
310.64
KB
-rwxr-xr-x
dpkg-architecture
14.85
KB
-rwxr-xr-x
dpkg-buildflags
8.14
KB
-rwxr-xr-x
dpkg-buildpackage
32.63
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
166.52
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
154.55
KB
-rwxr-xr-x
dpkg-genbuildinfo
18.48
KB
-rwxr-xr-x
dpkg-genchanges
17.39
KB
-rwxr-xr-x
dpkg-gencontrol
14.2
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.88
KB
-rwxr-xr-x
dpkg-name
6.62
KB
-rwxr-xr-x
dpkg-parsechangelog
4.83
KB
-rwxr-xr-x
dpkg-query
158.58
KB
-rwxr-xr-x
dpkg-realpath
4.09
KB
-rwxr-xr-x
dpkg-scanpackages
8.47
KB
-rwxr-xr-x
dpkg-scansources
8.98
KB
-rwxr-xr-x
dpkg-shlibdeps
31.17
KB
-rwxr-xr-x
dpkg-source
22.91
KB
-rwxr-xr-x
dpkg-split
126.48
KB
-rwxr-xr-x
dpkg-statoverride
62.33
KB
-rwxr-xr-x
dpkg-trigger
86.48
KB
-rwxr-xr-x
dpkg-vendor
3.18
KB
-rwxr-xr-x
du
171.33
KB
-rwxr-xr-x
dwp
1.79
MB
-rwxr-xr-x
ec2-metadata
7.71
KB
-rwxr-xr-x
ec2metadata
8.38
KB
-rwxr-xr-x
echo
42.83
KB
-rwxr-xr-x
editor
280.74
KB
-rwxr-xr-x
egrep
41
B
-rwxr-xr-x
eject
82.16
KB
-rwxr-xr-x
elfedit
35.03
KB
-rwxr-xr-x
enc2xs
40.96
KB
-rwxr-xr-x
encguess
3
KB
-rwxr-xr-x
env
47.4
KB
-rwxr-xr-x
envsubst
34.31
KB
-rwxr-xr-x
eqn
205.42
KB
-rwxr-xr-x
ex
3.48
MB
-rwxr-xr-x
expand
42.92
KB
-rwxr-xr-x
expiry
30.45
KB
-rwxr-sr-x
expr
115.05
KB
-rwxr-xr-x
factor
83.2
KB
-rwxr-xr-x
faillog
22.53
KB
-rwxr-xr-x
fallocate
34.31
KB
-rwxr-xr-x
false
34.83
KB
-rwxr-xr-x
fgrep
41
B
-rwxr-xr-x
filan
96.02
KB
-rwxr-xr-x
file
26.48
KB
-rwxr-xr-x
fincore
34.36
KB
-rwxr-xr-x
find
219.58
KB
-rwxr-xr-x
findmnt
83.59
KB
-rwxr-xr-x
flock
34.39
KB
-rwxr-xr-x
fmt
46.89
KB
-rwxr-xr-x
fold
42.89
KB
-rwxr-xr-x
free
26.3
KB
-rwxr-xr-x
funzip
22.46
KB
-rwxr-xr-x
fuser
39.83
KB
-rwxr-xr-x
g++
1.25
MB
-rwxr-xr-x
g++-12
1.25
MB
-rwxr-xr-x
gcc
1.24
MB
-rwxr-xr-x
gcc-12
1.24
MB
-rwxr-xr-x
gcc-ar
34.54
KB
-rwxr-xr-x
gcc-ar-12
34.54
KB
-rwxr-xr-x
gcc-nm
34.54
KB
-rwxr-xr-x
gcc-nm-12
34.54
KB
-rwxr-xr-x
gcc-ranlib
34.54
KB
-rwxr-xr-x
gcc-ranlib-12
34.54
KB
-rwxr-xr-x
gcov
720.16
KB
-rwxr-xr-x
gcov-12
720.16
KB
-rwxr-xr-x
gcov-dump
568.02
KB
-rwxr-xr-x
gcov-dump-12
568.02
KB
-rwxr-xr-x
gcov-tool
588.09
KB
-rwxr-xr-x
gcov-tool-12
588.09
KB
-rwxr-xr-x
gencat
26.75
KB
-rwxr-xr-x
genisoimage
631.17
KB
-rwxr-xr-x
geqn
205.42
KB
-rwxr-xr-x
getconf
26.5
KB
-rwxr-xr-x
geteltorito
6.06
KB
-rwxr-xr-x
getent
35.47
KB
-rwxr-xr-x
getfacl
30.8
KB
-rwxr-xr-x
getopt
34.31
KB
-rwxr-xr-x
gettext
34.31
KB
-rwxr-xr-x
gettext.sh
5.07
KB
-rwxr-xr-x
git
3.54
MB
-rwxr-xr-x
git-receive-pack
3.54
MB
-rwxr-xr-x
git-shell
2.04
MB
-rwxr-xr-x
git-upload-archive
3.54
MB
-rwxr-xr-x
git-upload-pack
3.54
MB
-rwxr-xr-x
gmake
234.65
KB
-rwxr-xr-x
gold
2.99
MB
-rwxr-xr-x
gonit
8.2
MB
-rwxr-xr-x
gp-archive
159.06
KB
-rwxr-xr-x
gp-collect-app
175.27
KB
-rwxr-xr-x
gp-display-html
578.29
KB
-rwxr-xr-x
gp-display-src
150.81
KB
-rwxr-xr-x
gp-display-text
257.3
KB
-rwxr-xr-x
gpasswd
86.42
KB
-rwsr-xr-x
gpgv
463
KB
-rwxr-xr-x
gpic
220.27
KB
-rwxr-xr-x
gprof
108.35
KB
-rwxr-xr-x
gprofng
146.59
KB
-rwxr-xr-x
grep
198.39
KB
-rwxr-xr-x
grep-aptavail
52.54
KB
-rwxr-xr-x
grep-available
52.54
KB
-rwxr-xr-x
grep-dctrl
52.54
KB
-rwxr-xr-x
grep-debtags
52.54
KB
-rwxr-xr-x
grep-status
52.54
KB
-rwxr-xr-x
groff
125.45
KB
-rwxr-xr-x
grog
2.71
KB
-rwxr-xr-x
grops
185.86
KB
-rwxr-xr-x
grotty
137.48
KB
-rwxr-xr-x
groups
42.89
KB
-rwxr-xr-x
growpart
29.19
KB
-rwxr-xr-x
grub-editenv
374.16
KB
-rwxr-xr-x
grub-file
809.41
KB
-rwxr-xr-x
grub-fstest
931.13
KB
-rwxr-xr-x
grub-glue-efi
245.01
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
229.05
KB
-rwxr-xr-x
grub-mkfont
273.66
KB
-rwxr-xr-x
grub-mkimage
354.2
KB
-rwxr-xr-x
grub-mklayout
249.29
KB
-rwxr-xr-x
grub-mknetdir
410.99
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
257.35
KB
-rwxr-xr-x
grub-mkrelpath
244.7
KB
-rwxr-xr-x
grub-mkrescue
987.84
KB
-rwxr-xr-x
grub-mkstandalone
487.32
KB
-rwxr-xr-x
grub-mount
754.05
KB
-rwxr-xr-x
grub-render-label
822.01
KB
-rwxr-xr-x
grub-script-check
272.82
KB
-rwxr-xr-x
grub-syslinux2cfg
770.52
KB
-rwxr-xr-x
gtbl
146.43
KB
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
95.84
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.51
KB
-rwxr-xr-x
hardlink
50.39
KB
-rwxr-xr-x
hd
58.32
KB
-rwxr-xr-x
head
46.95
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
58.32
KB
-rwxr-xr-x
host
114.7
KB
-rwxr-xr-x
hostid
38.83
KB
-rwxr-xr-x
hostname
22.15
KB
-rwxr-xr-x
hostnamectl
30.38
KB
-rwxr-xr-x
i386
26.58
KB
-rwxr-xr-x
iconv
63.13
KB
-rwxr-xr-x
id
47.02
KB
-rwxr-xr-x
ifnames
4.08
KB
-rwxr-xr-x
infocmp
62.31
KB
-rwxr-xr-x
infotocap
90.34
KB
-rwxr-xr-x
install
155.8
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
34.31
KB
-rwxr-xr-x
ip
674.82
KB
-rwxr-xr-x
ipcmk
34.38
KB
-rwxr-xr-x
ipcrm
34.31
KB
-rwxr-xr-x
ipcs
74.31
KB
-rwxr-xr-x
iptables-xml
88.98
KB
-rwxr-xr-x
ischroot
14.32
KB
-rwxr-xr-x
isodump
180.17
KB
-rwxr-xr-x
isoinfo
343.42
KB
-rwxr-xr-x
isovfy
184.14
KB
-rwxr-xr-x
join
54.98
KB
-rwxr-xr-x
join-dctrl
35.13
KB
-rwxr-xr-x
journalctl
74.64
KB
-rwxr-xr-x
json-patch-jsondiff
1004
B
-rwxr-xr-x
json_pp
4.88
KB
-rwxr-xr-x
jsondiff
1004
B
-rwxr-xr-x
jsonpatch
3.77
KB
-rwxr-xr-x
jsonpointer
1.79
KB
-rwxr-xr-x
jsonschema
213
B
-rwxr-xr-x
kernel-install
12.75
KB
-rwxr-xr-x
kill
22.3
KB
-rwxr-xr-x
killall
31.95
KB
-rwxr-xr-x
kmod
174.27
KB
-rwxr-xr-x
last
50.31
KB
-rwxr-xr-x
lastb
50.31
KB
-rwxr-xr-x
lastlog
31.75
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.27
MB
-rwxr-xr-x
ld.bfd
1.27
MB
-rwxr-xr-x
ld.gold
2.99
MB
-rwxr-xr-x
ld.so
209.96
KB
-rwxr-xr-x
ldd
5.28
KB
-rwxr-xr-x
less
194.3
KB
-rwxr-xr-x
lessecho
14.24
KB
-rwxr-xr-x
lessfile
8.83
KB
-rwxr-xr-x
lesskey
23.63
KB
-rwxr-xr-x
lesspipe
8.83
KB
-rwxr-xr-x
lexgrog
107.48
KB
-rwxr-xr-x
lft
2.43
KB
-rwxr-xr-x
lft.db
2.43
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
133.12
KB
-rwxr-xr-x
link
38.83
KB
-rwxr-xr-x
linux-check-removal
4.56
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
26.58
KB
-rwxr-xr-x
linux64
26.58
KB
-rwxr-xr-x
ln
71.12
KB
-rwxr-xr-x
lnstat
26.59
KB
-rwxr-xr-x
locale
46.16
KB
-rwxr-xr-x
localectl
26.38
KB
-rwxr-xr-x
localedef
291.91
KB
-rwxr-xr-x
logger
54.9
KB
-rwxr-xr-x
login
51.78
KB
-rwxr-xr-x
loginctl
58.48
KB
-rwxr-xr-x
logname
38.83
KB
-rwxr-xr-x
look
18.31
KB
-rwxr-xr-x
ls
147.8
KB
-rwxr-xr-x
lsattr
14.24
KB
-rwxr-xr-x
lsb_release
2.59
KB
-rwxr-xr-x
lsblk
202.31
KB
-rwxr-xr-x
lscpu
126.31
KB
-rwxr-xr-x
lsfd
120.3
KB
-rwxr-xr-x
lsinitramfs
735
B
-rwxr-xr-x
lsipc
98.31
KB
-rwxr-xr-x
lsirq
34.48
KB
-rwxr-xr-x
lslocks
70.7
KB
-rwxr-xr-x
lslogins
94.31
KB
-rwxr-xr-x
lsmem
66.31
KB
-rwxr-xr-x
lsmod
174.27
KB
-rwxr-xr-x
lsns
82.31
KB
-rwxr-xr-x
lspci
104.04
KB
-rwxr-xr-x
lto-dump
30.47
MB
-rwxr-xr-x
lto-dump-12
30.47
MB
-rwxr-xr-x
lzcat
82.7
KB
-rwxr-xr-x
lzcmp
7.25
KB
-rwxr-xr-x
lzdiff
7.25
KB
-rwxr-xr-x
lzegrep
10.09
KB
-rwxr-xr-x
lzfgrep
10.09
KB
-rwxr-xr-x
lzgrep
10.09
KB
-rwxr-xr-x
lzless
1.77
KB
-rwxr-xr-x
lzma
82.7
KB
-rwxr-xr-x
lzmainfo
14.3
KB
-rwxr-xr-x
lzmore
2.14
KB
-rwxr-xr-x
m4
271.52
KB
-rwxr-xr-x
make
234.65
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
man
121.36
KB
-rwxr-xr-x
man-recode
35.38
KB
-rwxr-xr-x
mandb
147.61
KB
-rwxr-xr-x
manpath
34.78
KB
-rwxr-xr-x
markdown-it
220
B
-rwxr-xr-x
mawk
154.66
KB
-rwxr-xr-x
mcookie
34.38
KB
-rwxr-xr-x
md5sum
50.95
KB
-rwxr-xr-x
md5sum.textutils
50.95
KB
-rwxr-xr-x
mdig
46.33
KB
-rwxr-xr-x
mesg
18.3
KB
-rwxr-xr-x
mkdir
95.27
KB
-rwxr-xr-x
mkfifo
67.17
KB
-rwxr-xr-x
mkisofs
631.17
KB
-rwxr-xr-x
mknod
71.2
KB
-rwxr-xr-x
mktemp
42.92
KB
-rwxr-xr-x
mkzftree
30.84
KB
-rwxr-xr-x
mokutil
60.27
KB
-rwxr-xr-x
monit
8.2
MB
-rwxr-xr-x
more
58.31
KB
-rwxr-xr-x
mount
58.3
KB
-rwsr-xr-x
mount-image-callback
13.86
KB
-rwxr-xr-x
mountpoint
18.3
KB
-rwxr-xr-x
mt
83.38
KB
-rwxr-xr-x
mt-gnu
83.38
KB
-rwxr-xr-x
mv
139.62
KB
-rwxr-xr-x
namei
34.31
KB
-rwxr-xr-x
nano
280.74
KB
-rwxr-xr-x
nawk
154.66
KB
-rwxr-xr-x
ncal
36.84
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netstat
151.66
KB
-rwxr-xr-x
networkctl
106.38
KB
-rwxr-xr-x
newgrp
47.75
KB
-rwsr-xr-x
ngettext
34.31
KB
-rwxr-xr-x
nice
42.86
KB
-rwxr-xr-x
nisdomainname
22.15
KB
-rwxr-xr-x
nl
111.11
KB
-rwxr-xr-x
nm
44.03
KB
-rwxr-xr-x
nohup
42.89
KB
-rwxr-xr-x
normalizer
244
B
-rwxr-xr-x
nproc
42.89
KB
-rwxr-xr-x
nroff
3.22
KB
-rwxr-xr-x
nsenter
34.54
KB
-rwxr-xr-x
nslookup
114.74
KB
-rwxr-xr-x
nstat
104.45
KB
-rwxr-xr-x
nsupdate
74.55
KB
-rwxr-xr-x
numfmt
67.02
KB
-rwxr-xr-x
objcopy
155.66
KB
-rwxr-xr-x
objdump
362.56
KB
-rwxr-xr-x
od
79.02
KB
-rwxr-xr-x
openssl
953.26
KB
-rwxr-xr-x
pager
194.3
KB
-rwxr-xr-x
partx
118.31
KB
-rwxr-xr-x
passwd
66.65
KB
-rwsr-xr-x
paste
42.89
KB
-rwxr-xr-x
patch
187.44
KB
-rwxr-xr-x
pathchk
42.86
KB
-rwxr-xr-x
pdb3
62.4
KB
-rwxr-xr-x
pdb3.11
62.4
KB
-rwxr-xr-x
peekfd
14.5
KB
-rwxr-xr-x
perl
3.63
MB
-rwxr-xr-x
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
perl5.36.0
3.63
MB
-rwxr-xr-x
perlbug
44.12
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
44.12
KB
-rwxr-xr-x
pgrep
34.42
KB
-rwxr-xr-x
pic
220.27
KB
-rwxr-xr-x
pico
280.74
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.31
KB
-rwxr-xr-x
pidwait
34.42
KB
-rwxr-xr-x
ping
88.45
KB
-rwxr-xr-x
ping4
88.45
KB
-rwxr-xr-x
ping6
88.45
KB
-rwxr-xr-x
pinky
47.05
KB
-rwxr-xr-x
pkaction
18.23
KB
-rwxr-xr-x
pkcheck
22.3
KB
-rwxr-xr-x
pkill
34.42
KB
-rwxr-xr-x
pkttyagent
18.23
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.69
KB
-rwxr-xr-x
pmap
34.34
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.68
KB
-rwxr-xr-x
pod2text
10.55
KB
-rwxr-xr-x
pod2usage
4.01
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
pr
79.11
KB
-rwxr-xr-x
preconv
66.43
KB
-rwxr-xr-x
printenv
34.83
KB
-rwxr-xr-x
printf
62.92
KB
-rwxr-xr-x
prlimit
38.83
KB
-rwxr-xr-x
procan
79.91
KB
-rwxr-xr-x
prove
13.34
KB
-rwxr-xr-x
prtstat
18.57
KB
-rwxr-xr-x
ps
142.93
KB
-rwxr-xr-x
pslog
14.45
KB
-rwxr-xr-x
pstree
35.78
KB
-rwxr-xr-x
pstree.x11
35.78
KB
-rwxr-xr-x
ptar
3.48
KB
-rwxr-xr-x
ptardiff
2.58
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
135.23
KB
-rwxr-xr-x
pwd
42.92
KB
-rwxr-xr-x
pwdx
14.3
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
13
KB
-rwxr-xr-x
py3versions
12.52
KB
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.11
79
B
-rwxr-xr-x
pygettext3
23.67
KB
-rwxr-xr-x
pygettext3.11
23.67
KB
-rwxr-xr-x
pygmentize
970
B
-rwxr-xr-x
pyserial-miniterm
975
B
-rwxr-xr-x
pyserial-ports
969
B
-rwxr-xr-x
python3
6.52
MB
-rwxr-xr-x
python3.11
6.52
MB
-rwxr-xr-x
pzstd
742.38
KB
-rwxr-xr-x
qemu-img
2.19
MB
-rwxr-xr-x
qemu-io
2.14
MB
-rwxr-xr-x
qemu-nbd
2.33
MB
-rwxr-xr-x
querybts
10.64
KB
-rwxr-xr-x
ranlib
51.17
KB
-rwxr-xr-x
rbash
1.21
MB
-rwxr-xr-x
rdma
180.6
KB
-rwxr-xr-x
readelf
751.38
KB
-rwxr-xr-x
readlink
50.89
KB
-rwxr-xr-x
realpath
50.92
KB
-rwxr-xr-x
rename.ul
22.3
KB
-rwxr-xr-x
renice
14.3
KB
-rwxr-xr-x
reportbug
110.11
KB
-rwxr-xr-x
reset
30.24
KB
-rwxr-xr-x
resize-part-image
4.23
KB
-rwxr-xr-x
resizepart
70.31
KB
-rwxr-xr-x
resolvectl
146.53
KB
-rwxr-xr-x
rev
14.3
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rm
71.05
KB
-rwxr-xr-x
rmdir
54.92
KB
-rwxr-xr-x
rnano
280.74
KB
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
95
KB
-rwxr-xr-x
rst-buildhtml
11.17
KB
-rwxr-xr-x
rst2html
592
B
-rwxr-xr-x
rst2html4
714
B
-rwxr-xr-x
rst2html5
1.03
KB
-rwxr-xr-x
rst2latex
791
B
-rwxr-xr-x
rst2man
614
B
-rwxr-xr-x
rst2odt
780
B
-rwxr-xr-x
rst2odt_prepstyles
2.01
KB
-rwxr-xr-x
rst2pseudoxml
599
B
-rwxr-xr-x
rst2s5
635
B
-rwxr-xr-x
rst2xetex
871
B
-rwxr-xr-x
rst2xml
600
B
-rwxr-xr-x
rstpep2html
668
B
-rwxr-xr-x
rtstat
26.59
KB
-rwxr-xr-x
run-parts
26.91
KB
-rwxr-xr-x
runcon
42.95
KB
-rwxr-xr-x
rview
3.48
MB
-rwxr-xr-x
rvim
3.48
MB
-rwxr-xr-x
salt-call
295
B
-rwxr-xr-x
salt-minion
299
B
-rwxr-xr-x
salt-pip
293
B
-rwxr-xr-x
salt-proxy
297
B
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
scalar
2.1
MB
-rwxr-xr-x
scp
266.63
KB
-rwxr-xr-x
screen
471.09
KB
-rwxr-xr-x
script
70.3
KB
-rwxr-xr-x
scriptlive
54.3
KB
-rwxr-xr-x
scriptreplay
46.3
KB
-rwxr-xr-x
sdiff
55.08
KB
-rwxr-xr-x
sed
123.46
KB
-rwxr-xr-x
select-editor
2.39
KB
-rwxr-xr-x
sensible-browser
1.26
KB
-rwxr-xr-x
sensible-editor
1.24
KB
-rwxr-xr-x
sensible-pager
565
B
-rwxr-xr-x
seq
58.92
KB
-rwxr-xr-x
setarch
26.58
KB
-rwxr-xr-x
setfacl
38.84
KB
-rwxr-xr-x
setpci
30.31
KB
-rwxr-xr-x
setpriv
78.31
KB
-rwxr-xr-x
setsid
14.3
KB
-rwxr-xr-x
setterm
46.31
KB
-rwxr-xr-x
sftp
282.59
KB
-rwxr-xr-x
sg
47.75
KB
-rwsr-xr-x
sh
122.7
KB
-rwxr-xr-x
sha1sum
54.95
KB
-rwxr-xr-x
sha224sum
58.95
KB
-rwxr-xr-x
sha256sum
58.95
KB
-rwxr-xr-x
sha384sum
62.95
KB
-rwxr-xr-x
sha512sum
62.95
KB
-rwxr-xr-x
shasum
9.75
KB
-rwxr-xr-x
shred
63.14
KB
-rwxr-xr-x
shuf
58.98
KB
-rwxr-xr-x
size
26.86
KB
-rwxr-xr-x
skill
30.33
KB
-rwxr-xr-x
slabtop
22.37
KB
-rwxr-xr-x
sleep
42.86
KB
-rwxr-xr-x
slogin
1.07
MB
-rwxr-xr-x
snice
30.33
KB
-rwxr-xr-x
socat
401.98
KB
-rwxr-xr-x
soelim
50.43
KB
-rwxr-xr-x
sort
115.68
KB
-rwxr-xr-x
sort-dctrl
38.98
KB
-rwxr-xr-x
splain
18.99
KB
-rwxr-xr-x
split
59.55
KB
-rwxr-xr-x
ss
189.14
KB
-rwxr-xr-x
ssh
1.07
MB
-rwxr-xr-x
ssh-add
518.44
KB
-rwxr-xr-x
ssh-agent
474.38
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
12.38
KB
-rwxr-xr-x
ssh-keygen
646.44
KB
-rwxr-xr-x
ssh-keyscan
622.47
KB
-rwxr-xr-x
stat
95.2
KB
-rwxr-xr-x
stdbuf
58.92
KB
-rwxr-xr-x
streamzip
7.75
KB
-rwxr-xr-x
strings
30.98
KB
-rwxr-xr-x
strip
155.7
KB
-rwxr-xr-x
stty
83.02
KB
-rwxr-xr-x
su
70.31
KB
-rwsr-xr-x
sudo
275.02
KB
-rwsr-xr-x
sudoedit
275.02
KB
-rwsr-xr-x
sudoreplay
115.7
KB
-rwxr-xr-x
sum
50.96
KB
-rwxr-xr-x
sync
38.89
KB
-rwxr-xr-x
systemctl
1.29
MB
-rwxr-xr-x
systemd
90.38
KB
-rwxr-xr-x
systemd-analyze
182.61
KB
-rwxr-xr-x
systemd-ask-password
18.48
KB
-rwxr-xr-x
systemd-cat
18.38
KB
-rwxr-xr-x
systemd-cgls
22.48
KB
-rwxr-xr-x
systemd-cgtop
38.4
KB
-rwxr-xr-x
systemd-creds
42.61
KB
-rwxr-xr-x
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
systemd-delta
26.38
KB
-rwxr-xr-x
systemd-detect-virt
18.37
KB
-rwxr-xr-x
systemd-escape
18.37
KB
-rwxr-xr-x
systemd-firstboot
50.59
KB
-rwxr-xr-x
systemd-hwdb
126.66
KB
-rwxr-xr-x
systemd-id128
22.37
KB
-rwxr-xr-x
systemd-inhibit
22.39
KB
-rwxr-xr-x
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
systemd-mount
50.59
KB
-rwxr-xr-x
systemd-notify
18.38
KB
-rwxr-xr-x
systemd-path
18.37
KB
-rwxr-xr-x
systemd-repart
150.69
KB
-rwxr-xr-x
systemd-run
58.57
KB
-rwxr-xr-x
systemd-socket-activate
26.38
KB
-rwxr-xr-x
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
systemd-sysext
42.49
KB
-rwxr-xr-x
systemd-sysusers
62.68
KB
-rwxr-xr-x
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
systemd-umount
50.59
KB
-rwxr-xr-x
tabs
18.23
KB
-rwxr-xr-x
tac
111.05
KB
-rwxr-xr-x
tail
75.14
KB
-rwxr-xr-x
tar
519.52
KB
-rwxr-xr-x
taskset
62.31
KB
-rwxr-xr-x
tbl
146.43
KB
-rwxr-xr-x
tbl-dctrl
39.04
KB
-rwxr-xr-x
tcpdump
1.21
MB
-rwxr-xr-x
tee
42.95
KB
-rwxr-xr-x
tempfile
14.18
KB
-rwxr-xr-x
test
58.89
KB
-rwxr-xr-x
tic
90.34
KB
-rwxr-xr-x
timedatectl
42.37
KB
-rwxr-xr-x
timeout
47.49
KB
-rwxr-xr-x
tload
18.32
KB
-rwxr-xr-x
toe
22.23
KB
-rwxr-xr-x
top
131.58
KB
-rwxr-xr-x
touch
107.05
KB
-rwxr-xr-x
tput
26.27
KB
-rwxr-xr-x
tr
54.89
KB
-rwxr-xr-x
traceproto
2.82
KB
-rwxr-xr-x
traceproto.db
2.82
KB
-rwxr-xr-x
traceroute
71.23
KB
-rwxr-xr-x
traceroute-nanog
1.58
KB
-rwxr-xr-x
traceroute.db
71.23
KB
-rwxr-xr-x
traceroute6
71.23
KB
-rwxr-xr-x
traceroute6.db
71.23
KB
-rwxr-xr-x
troff
755.83
KB
-rwxr-xr-x
true
34.83
KB
-rwxr-xr-x
truncate
42.89
KB
-rwxr-xr-x
tset
30.24
KB
-rwxr-xr-x
tsort
54.89
KB
-rwxr-xr-x
tty
34.86
KB
-rwxr-xr-x
tzselect
14.99
KB
-rwxr-xr-x
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
ucf
40.69
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.85
KB
-rwxr-xr-x
uclampset
62.31
KB
-rwxr-xr-x
udevadm
1.29
MB
-rwxr-xr-x
ul
22.31
KB
-rwxr-xr-x
umount
34.3
KB
-rwsr-xr-x
uname
42.86
KB
-rwxr-xr-x
unattended-upgrade
97.21
KB
-rwxr-xr-x
unattended-upgrades
97.21
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
42.92
KB
-rwxr-xr-x
uniq
46.95
KB
-rwxr-xr-x
unlink
38.83
KB
-rwxr-xr-x
unlzma
82.7
KB
-rwxr-xr-x
unmkinitramfs
3.59
KB
-rwxr-xr-x
unshare
82.54
KB
-rwxr-xr-x
unxz
82.7
KB
-rwxr-xr-x
unzip
175.05
KB
-rwxr-xr-x
unzipsfx
82.86
KB
-rwxr-xr-x
unzstd
1.22
MB
-rwxr-xr-x
update-alternatives
58.31
KB
-rwxr-xr-x
uptime
14.3
KB
-rwxr-xr-x
users
38.89
KB
-rwxr-xr-x
utmpdump
30.3
KB
-rwxr-xr-x
uuidgen
18.3
KB
-rwxr-xr-x
uuidparse
42.31
KB
-rwxr-xr-x
vcs-run
6.75
KB
-rwxr-xr-x
vdir
147.8
KB
-rwxr-xr-x
vi
3.48
MB
-rwxr-xr-x
view
3.48
MB
-rwxr-xr-x
vim
3.48
MB
-rwxr-xr-x
vim.basic
3.48
MB
-rwxr-xr-x
vim.tiny
1.55
MB
-rwxr-xr-x
vimdiff
3.48
MB
-rwxr-xr-x
vimtutor
2.1
KB
-rwxr-xr-x
vmstat
34.72
KB
-rwxr-xr-x
w
22.3
KB
-rwxr-xr-x
wall
38.3
KB
-rwxr-xr-x
watch
26.71
KB
-rwxr-xr-x
wc
51.05
KB
-rwxr-xr-x
wdctl
70.34
KB
-rwxr-xr-x
wget
459.36
KB
-rwxr-xr-x
whatis
51.29
KB
-rwxr-xr-x
whereis
30.77
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
which.debianutils
946
B
-rwxr-xr-x
whiptail
26.75
KB
-rwxr-xr-x
who
59.02
KB
-rwxr-xr-x
whoami
38.86
KB
-rwxr-xr-x
write
22.31
KB
-rwxr-xr-x
write-mime-multipart
3.54
KB
-rwxr-xr-x
x86_64
26.58
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
23.14
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-as
897.41
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
18.51
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
1.79
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
35.03
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-12
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-12
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-12
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-12
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-gp-archive
159.06
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-collect-ap...
175.27
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-ht...
578.29
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-sr...
150.81
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-te...
257.3
KB
-rwxr-xr-x
x86_64-linux-gnu-gprof
108.35
KB
-rwxr-xr-x
x86_64-linux-gnu-gprofng
146.59
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump-12
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
44.03
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
155.66
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
362.56
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
751.38
KB
-rwxr-xr-x
x86_64-linux-gnu-size
26.86
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
30.98
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
155.7
KB
-rwxr-xr-x
xargs
70.45
KB
-rwxr-xr-x
xmlcatalog
22.23
KB
-rwxr-xr-x
xmllint
74.91
KB
-rwxr-xr-x
xsubpp
5.05
KB
-rwxr-xr-x
xz
82.7
KB
-rwxr-xr-x
xzcat
82.7
KB
-rwxr-xr-x
xzcmp
7.25
KB
-rwxr-xr-x
xzdiff
7.25
KB
-rwxr-xr-x
xzegrep
10.09
KB
-rwxr-xr-x
xzfgrep
10.09
KB
-rwxr-xr-x
xzgrep
10.09
KB
-rwxr-xr-x
xzless
1.77
KB
-rwxr-xr-x
xzmore
2.14
KB
-rwxr-xr-x
yes
38.83
KB
-rwxr-xr-x
ypdomainname
22.15
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
6.31
KB
-rwxr-xr-x
zdump
22.52
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
212.27
KB
-rwxr-xr-x
zipcloak
92.48
KB
-rwxr-xr-x
zipdetails
68.55
KB
-rwxr-xr-x
zipgrep
2.89
KB
-rwxr-xr-x
zipinfo
175.05
KB
-rwxr-xr-x
zipnote
84.16
KB
-rwxr-xr-x
zipsplit
88.19
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
zstd
1.22
MB
-rwxr-xr-x
zstdcat
1.22
MB
-rwxr-xr-x
zstdgrep
3.78
KB
-rwxr-xr-x
zstdless
197
B
-rwxr-xr-x
zstdmt
1.22
MB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : ucf
#!/bin/sh # -*- Mode: Sh -*- # updateConfFile.sh --- # Author : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) # Created On : Fri Feb 1 03:41:47 2002 # Created On Node : glaurung.green-gryphon.com # Last Modified By : Manoj Srivastava # Last Modified On : Tue Jun 6 09:48:22 2006 # Last Machine Used: glaurung.internal.golden-gryphon.com # Update Count : 186 # Status : Unknown, Use with caution! # HISTORY : # Description : # # This script attempts to provide conffile like handling for files not # shipped in a Debian package, but handled by the postinst. Using this # script, one may ship a bunch of default cofiguration files somewhere # in /usr (/usr/share/<pkg> is a good location), and maintain files in # /etc. # # The motivation for this script was to provide conffile like handling # for start files for emacs lisp packages (for example, # /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not # shipped with the package, instead, they are installed during the # post installation configuration phase by the script # /usr/lib/emacsen-common/emacs-package-install $package_name. # # This script is meant to be invoked by the packages install script at # /usr/lib/emacsen-common/packages/install/$package_name for each # flavour of installed emacsen by calling it with the proper values of # new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file # (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest. # # make sure we exit on error set -e # set the version and revision progname="$(basename $0)" pversion='Revision: 3.00 ' unset GREP_OPTIONS ###################################################################### ######## ######### ######## Utility functions ######### ######## ######### ###################################################################### setq() { # Variable Value Doc_string if [ "x$2" = "x" ]; then echo >&2 "$progname: Unable to determine $3" exit 1; else if [ "x$VERBOSE" != "x" ]; then echo >&2 "$progname: $3 is $2"; fi eval "$1=\"\$2\""; fi } # Usage: get_file_metadate file_name get_file_metadata() { if [ -e "$1" ]; then # get file modification date without the nanoseconds and timezone info local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))" # print file_name user.group permissions above_date stat --format "%n %U.%G 0%a $moddate" "$1" else echo "/dev/null" fi } # Runs the diff command with approrpiate arguments # Usage run_diff diff|sdiff diff_opts old_file new_file run_diff() { local diff_cmd="$1" local diff_opt="$2" local old_file="$3" local new_file="$4" # Note: get_file_metadata not in quotes to ignore "\n" characters local old_file_label="$(get_file_metadata "$old_file")" local new_file_label="$(get_file_metadata "$new_file")" [ -e "$old_file" ] || old_file=/dev/null [ -e "$new_file" ] || new_file=/dev/null if [ "$diff_cmd" = "diff" ] ; then diff "$diff_opt" --label "$old_file_label" "$old_file" \ --label "$new_file_label" "$new_file" || true elif [ "$diff_cmd" = "sdiff" ] ; then # unfortunatelly the sdiff command does not support --label option local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \ "$old_file_label" "$new_file_label" "$out" else echo "Unknown diff command: $diff_cmd" >&2 exit 1 fi } # Use debconf to show the differences # Usage: show_diff actual_file_differences file_stat_differences show_diff() { if [ -z "$1" ]; then DIFF="There are no non-white space differences in the files." else if [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then DIFF="The differences between the files are too large to display." else DIFF="$1" fi fi if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then templ=ucf/show_diff db_capb escape db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)" db_fset $templ seen false db_input critical $templ || true db_go || true db_get $templ # may contain sensitive information, so clear # immediatly after use so it is never written # to disk db_subst $templ DIFF "" db_reset $templ db_capb else if [ -z "$my_pager" ]; then echo "$DIFF" | sensible-pager else echo "$DIFF" | $my_pager fi fi } withecho () { echo "$@" >&2 "$@" } usageversion () { cat >&2 <<END Debian GNU/Linux $progname $pversion. Copyright (C) 2002-2005 Manoj Srivastava. This is free software; see the GNU General Public Licence for copying conditions. There is NO warranty. Usage: $progname [options] new_file destination Options: -h, --help print this message -s foo, --src-dir foo Set the src dir (historical md5sums live here) --sum-file bar Force the historical md5sums to be read from this file. Overrides any setting of --src-dir. -d[n], --debug=[n] Set the Debug level to N. Please note there must be no spaces before the debug level -n, --no-action Dry run. No action is actually taken. -P foo, --package foo Don't follow dpkg-divert diversions by package foo. -v, --verbose Make the script verbose --three-way Register this file in the cache, and turn on the diff3 option allowing the merging of maintainer changes into a (potentially modified) local configuration file. ) --state-dir bar Set the state directory to bar instead of the default '/var/lib/ucf'. Used mostly for testing. --debconf-ok Indicate that it is ok for ucf to use an already running debconf instance for prompting. --debconf-template bar Specify an alternate, caller-provided debconf template to use for prompting. Usage: $progname -p destination -p, --purge Remove any reference to destination from records By default, the directory the new_file lives in is assumed to be the src-dir, which is where we look for any historical md5sums. END } ###################################################################### ######## ######### ######## file and hash save/restore functions ######### ######## ######### ###################################################################### purge_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 \ || true; fi #echo "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; if [ "X$docmd" = "XYES" ]; then mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" else echo mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" fi set -e fi fi test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file" if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then $action rm -f "$statedir/cache/$cached_file" fi } replace_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2; fi grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \ "$statedir/hashfile.tmp"; mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" set -e else echo "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\"" echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; " echo ") | sort > \"$statedir/hashfile\"" fi else if [ "X$docmd" = "XYES" ]; then md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" > \ "$statedir/hashfile" else echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \ "\"$statedir/hashfile\"" fi fi file_size=$(stat -c '%s' "$orig_new_file") if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then $action cp -pf "$orig_new_file" "$statedir/cache/$cached_file" fi # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" } replace_conf_file () { # do not mangle $dest_file since it's the one registered in the hashfile # or we have been ask to register real_file="$dest_file" if [ -L "$dest_file" ]; then real_file="$(readlink -nf $dest_file || :)" if [ "x$real_file" = "x" ]; then echo >&2 "$dest_file is a broken symlink!" $action rm -f "$dest_file"; real_file="$dest_file" fi fi if [ -e "$real_file" ]; then if [ -z "$RETAIN_OLD" ]; then #echo "Saving ${real_file}.${OLD_SUFFIX}, in case." if [ "x$VERBOSE" != "x" ]; then echo >&2 "Not saving ${real_file}, since it was unmodified" fi else $action cp -pf $selinux "${real_file}" "${real_file}.${OLD_SUFFIX}" fi fi if [ -e "${real_file}" ]; then # Do not change the permissions and attributes of the destination $action cp -f $selinux "$new_file" "${real_file}" else # No destination file exists $action cp -pf $selinux "$new_file" "${real_file}" fi replace_md5sum; } # Escape single quotes in the arguments passed in quote_single() { printf "%s\n" "$1" | sed -e "s,','\\\\'',g" } ###################################################################### ######## ######### ######## Command line args ######### ######## ######### ###################################################################### # # Long term variables# # docmd='YES' action='withecho' action= selinux='' DEBUG=0 VERBOSE='' statedir='/var/lib/ucf'; THREEWAY= DIST_SUFFIX="ucf-dist" NEW_SUFFIX="ucf-new" OLD_SUFFIX="ucf-old" ERR_SUFFIX="merge-error" # save up the cmdline with proper quoting/escaping saved= for arg in "$@"; do saved="${saved:+$saved }'$(quote_single "$arg")'" done # Note that we use `"$@"' to let each command-line parameter expand to a # separate word. The quotes around `$@' are essential! # We need TEMP as the `eval set --' would nuke the return value of getopt. TEMP=$(getopt -a -o hs:d::D::npP:Zv -n "$progname" \ --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,package:,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \ -- "$@") # Note the quotes around `$TEMP': they are essential! eval set -- "$TEMP" while true ; do case "$1" in -h|--help) usageversion; exit 0 ;; -n|--no-action) action='echo'; docmd='NO'; shift ;; -v|--verbose) VERBOSE=1; shift ;; -P|--package) opt_package="$2"; shift 2 ;; -s|--src-dir) opt_source_dir="$2"; shift 2 ;; --sum-file) opt_old_mdsum_file="$2"; shift 2 ;; --state-dir) opt_state_dir="$2"; shift 2 ;; --debconf-template) override_template="$2"; shift 2 ;; -D|-d|--debug|--DEBUG) # d has an optional argument. As we are in quoted mode, # an empty parameter will be generated if its optional # argument is not found. case "$2" in "") setq DEBUG 1 "The Debug value"; shift 2 ;; *) setq DEBUG "$2" "The Debug value"; shift 2 ;; esac ;; -p|--purge) PURGE=YES; shift ;; --three-way) THREEWAY=YES; shift ;; --debconf-ok) DEBCONF_OK=YES; shift ;; -Z) selinux='-Z'; shift ;; --) shift ; break ;; *) echo >&2 "Internal error!" ; exit 1 ;; esac done ###################################################################### ######## ######### ######## Sanity checking ######### ######## ######### ###################################################################### # Need to run as root, or else the if test "$(id -u)" != 0; then if [ "$docmd" = "YES" ]; then echo "$progname: Need to be run as root." >&2 echo "$progname: Setting up no action mode." >&2 action='echo'; docmd='NO'; fi fi if [ "X$PURGE" = "XYES" ]; then if [ $# != 1 ]; then echo >&2 "*** ERROR: Need exactly one argument when purging, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_dest_file="$1"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi else if [ $# != 2 ]; then echo >&2 "*** ERROR: Need exactly two arguments, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_new_file="$1"; temp_dest_file="$2"; if [ ! -e "${temp_new_file}" ]; then echo >&2 "Error: The new file ${temp_new_file} does not exist!"; exit 1; fi setq new_file "$(readlink -q -m $temp_new_file)" "The new file"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi fi # Follow dpkg-divert as though we are installed as part of $opt_package divert_line=$(dpkg-divert --listpackage "$dest_file") if [ -n "$divert_line" ]; then # name of the package or 'LOCAL' for a local diversion divert_package="$divert_line" if [ "$divert_package" != "$opt_package" ]; then dest_file=$(dpkg-divert --truename "$dest_file") fi fi safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"') ###################################################################### ######## ######### ######## Set Default Values ######### ######## ######### ###################################################################### # Load site defaults and over rides. if [ -f /etc/ucf.conf ]; then . /etc/ucf.conf fi # Command line, env variable, config file, or default if [ ! "x$opt_source_dir" = "x" ]; then setq source_dir "$opt_source_dir" "The Source directory" elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then setq source_dir "$UCF_SOURCE_DIR" "The Source directory" elif [ ! "x$conf_source_dir" = "x" ]; then setq source_dir "$conf_source_dir" "The Source directory" else if [ "X$new_file" != "X" ]; then setq source_dir "$(dirname $new_file)" "The Source directory" else setq source_dir "/tmp" "The Source directory" fi fi if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then my_pager="$(which $PAGER)"; elif [ -s /usr/bin/pager ] && [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then my_pager=/usr/bin/pager elif [ -x /usr/bin/sensible-pager ]; then my_pager=/usr/bin/sensible-pager elif [ -x /bin/more ]; then my_pager=/bin/more else my_pager= fi # Command line, env variable, config file, or default if [ ! "x$opt_state_dir" = "x" ]; then setq statedir "$opt_state_dir" "The State directory" elif [ ! "x$UCF_STATE_DIR" = "x" ]; then setq statedir "$UCF_STATE_DIR" "The State directory" elif [ ! "x$conf_state_dir" = "x" ]; then setq statedir "$conf_state_dir" "The State directory" else setq statedir '/var/lib/ucf' "The State directory" fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffold" = "x" ]; then setq force_conffold "$opt_force_conffold" "Keep the old file" elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file" elif [ ! "x$conf_force_conffold" = "x" ]; then setq force_conffold "$conf_force_conffold" "Keep the old file" else force_conffold='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffnew" = "x" ]; then setq force_conffnew "$opt_force_conffnew" "Replace the old file" elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file" elif [ ! "x$conf_force_conffnew" = "x" ]; then setq force_conffnew "$conf_force_conffnew" "Replace the old file" else force_conffnew='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffmiss" = "x" ]; then setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files" elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files" elif [ ! "x$conf_force_conffmiss" = "x" ]; then setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files" else force_conffmiss='' fi if [ -n "$opt_old_mdsum_file" ]; then setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here" elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here" elif [ ! "x$conf_old_mdsum_file" = "x" ]; then setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file" elif [ ! "x${new_file}" = "x" ]; then old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum"; else old_mdsum_file=""; fi ###################################################################### ######## ######### ######## More Sanity checking ######### ######## ######### ###################################################################### if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then echo >&2 "Error: Only one of force_conffold and force_conffnew should"; echo >&2 " be set"; exit 1; fi # VERBOSE of 0 is supposed to be the same as not setting VERBOSE if [ "X$VERBOSE" = "X0" ]; then VERBOSE='' fi # if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then echo >&2 "ucf: do not have write privilege to the state data" if [ "X$docmd" = "XYES" ]; then exit 1; fi fi if [ ! -d $statedir/cache ]; then $action mkdir -p $statedir/cache ; fi # test and see if this file exists in the database if [ -e "$statedir/hashfile" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "The hash file exists" echo >&2 "grep -E" "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true fi lastsum=$(grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \ awk '{print $1;}' ) fi if [ ! "x${new_file}" = "x" ]; then old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d"; else old_mdsum_dir=""; fi cached_file="$(echo $dest_file | tr / :)" ###################################################################### ######## ######### ######## Debugging dump ######### ######## ######### ###################################################################### if [ $DEBUG -gt 0 ]; then cat >&2 <<EOF The new start file is \`$new_file\' The destination is \`$dest_file\' (\`$safe_dest_file\') The history is kept under \'$source_dir\' The file may be cached at \'$statedir/cache/$cached_file\' EOF if [ -s "$dest_file" ]; then echo "The destination file exists, and has md5sum:" md5sum "$dest_file" else echo "The destination file does not exist." fi if [ "X$lastsum" != "X" ]; then echo "The old md5sum exists, and is:" echo "$lastsum" else echo "The old md5sum does not exist." if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then echo "However, there are historical md5sums around." fi fi if [ -e "$new_file" ]; then echo "The new file exists, and has md5sum:" md5sum "$new_file" else echo "The new file does not exist." fi if [ -d "$old_mdsum_dir" ]; then echo "The historical md5sum dir $old_mdsum_dir exists" elif [ -f "$old_mdsum_file" ]; then echo "The historical md5sum file $old_mdsum_file exists" else echo "Historical md5sums are not available" fi fi ###################################################################### ######## ######### ######## Short circuit if we are purging ######### ######## ######### ###################################################################### if [ "X$PURGE" = "XYES" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "Preparing to purge ${dest_file}" fi purge_md5sum; exit 0; fi # now we can restore $@ eval set -- "$saved" ###################################################################### ######## ######### ######## DebConf stuff ######### ######## ######### ###################################################################### # Is debconf already running? Kinda tricky, because it will be after the # confmodule is sourced, so only test before that. if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then if [ "$DEBIAN_HAS_FRONTEND" ]; then DEBCONF_ALREADY_RUNNING='YES' else DEBCONF_ALREADY_RUNNING='NO' fi fi export DEBCONF_ALREADY_RUNNING if [ -z "$DEBCONF_OK" ]; then if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then DEBCONF_OK='NO' else DEBCONF_OK='YES' fi fi # Time to start nagging the users who call ucf without debconf-ok if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then # Commented out for now, uncomment after a while to begin nagging # maintainers to fix their scripts. cat \ <<END *** WARNING: ucf was run from a maintainer script that uses debconf, but the script did not pass --debconf-ok to ucf. The maintainer script should be fixed to not stop debconf before calling ucf, and pass it this parameter. For now, ucf will revert to using old-style, non-debconf prompting. Ugh! Please inform the package maintainer about this problem. END fi # Start up debconf or at least get the db_* commands available if [ -e /usr/share/debconf/confmodule ]; then if test "$(id -u)" = 0; then . /usr/share/debconf/confmodule # Load our templates, just in case our template has # not been loaded or the Debconf DB lost or corrupted # since then, but only if it is OK to use debconf. if [ "$DEBCONF_OK" = 'YES' ]; then db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf fi else echo >&2 "$progname: Not loading confmodule, since we are not running as root." fi # Only set the title if debconf was not already running. # If it was running, then we do not want to clobber the # title used for configuring the whole package with debconf. if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then if ! db_settitle ucf/title 2>/dev/null; then # Older debconf that does not support that command. if test "$(id -u)" = 0; then db_title "Modified configuration file" else echo >&2 "$progname: Not changing title, since we are not running as root." fi fi fi fi ###################################################################### ######## ######### ######## Start Processing ######### ######## ######### ###################################################################### orig_new_file="$new_file" # Since sometimes we replace the newfile below newsum=$(md5sum "$new_file" | awk '{print $1}') # Determine the action for the current file. The default is to ask, # with non-replacement being the norm. # If the config dir exists # if file in always overwrite, state +=1; # fi # if file in never overwrite, state +=2; # fi # if file in ask; state +=4 # fi # if state == 0; then state = default # if state >= 4; ask # if state == 3; ask # if state == 2; exit # if state == 1; then replace_conffile; exit ###################################################################### ######## ######### ######## Do the replacement ######### ######## ######### ###################################################################### # Step 1: If we have no record of this file, and dest file # does, We need to determine how to initialize the # ${old_mdsum_prefix}.old file.. if [ -e "$dest_file" ]; then destsum=$(md5sum "$dest_file" | awk '{print $1}'); if [ "X$lastsum" = "X" ]; then # a: If we have a directory containing historical md5sums of this # file in question, we should look and see if the currently # installed file matches any of the old md5sums; in which case # it can be silently replaced. if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then if [ -d "$old_mdsum_dir" ]; then for file in ${old_mdsum_dir}/*; do oldsum="$(awk '{print $1}' $file)"; if [ "$oldsum" = "$destsum" ]; then if [ "X$force_conffold" = "X" ]; then # Bingo! replace, set the md5sum, and we are done if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi done elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "^${destsum}" "$old_mdsum_file" || true) if [ "X$oldsum" != "X" ]; then # Bingo if [ "X$force_conffold" = "X" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi fi # Well, nothing matched. We now check to see if the # maintainer has an opinion on how to set the ``md5sum of the # previously installed version'', since we have no way of # determining that automatically. Please note that unless # there are limited number of previously released packages # (like just one), the maintainer is also making a guess at # this point by supplying a historical md5sum default file. if [ "X$VERBOSE" != "X" ]; then echo >&2 "Historical md5sums did not match." fi if [ -d "$old_mdsum_dir" ]; then if [ -e "${old_mdsum_dir}/default" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "However, a default entry exists, using it." fi lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)" do_replace_md5sum=1; fi elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "[[:space:]]default$" "$old_mdsum_file" | \ awk '{print $1;}') if [ "X$oldsum" != "X" ]; then # Bingo lastsum=$oldsum; do_replace_md5sum=1; fi fi fi # At this point, we are almost certain that either the # historical record of md5sums is not complete, or the user has # changed the configuration file. Rather than guessing and # chosing one of the historical md5sums, we fall through to the # solution used if there had been no historical md5sums # directory/file. if [ "X$lastsum" = "X" ]; then # b: We do not have a historical list of md5sums, or none # matched, and we still need to initialize the # ${old_mdsum_prefix}.old file. We can't determine whther or # not they made any changes, so we err on the side of caution # and ask' if [ "X$VERBOSE" != "X" ]; then echo >&2 "No match found, we shall ask." fi lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; fi # the old md5sum file does not exist, and the historical # record failed fi # the old md5sum file does not exist (bug)) else # "$dest_file" does not exist # Step 2: If destfile does not exist, create it, set the file # "${old_mdsum_prefix}.old" to the md5sum of the new file, and we # are done if [ "X$lastsum" = "X" ]; then # Ok, so there is no indication that the package was ever # installed on this machine. echo >&2 "" echo >&2 "Creating config file $dest_file with new version" replace_conf_file; exit 0; elif [ "$lastsum" = "$newsum" ]; then # OK, new version of the file is the same as the last version # we saw. Since the user apparently has deleted the file, # nothing needs be done, unless we have been told differently if [ "X$force_conffmiss" != "X" ]; then echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else echo >&2 "Not replacing deleted config file $dest_file"; fi else # OK. New upstream version. if [ "X$force_conffmiss" != "X" ]; then # User has said to replace missing files, so we do so, no # questions asked. echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else # Even though the user has deleted this file, they should # be asked now, unless specified otherwise. if [ "X$force_conffold" = "X" ]; then destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; else exit 0; fi fi fi fi # Here, the destfile exists. # step 3: If the old md5sum and the md5sum of the new file # do not match, we need to take action. if [ "$lastsum" = "$newsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums match, nothing needs be done." fi if [ "X$do_replace_md5sum" != "X" ]; then replace_md5sum; fi exit 0; # Hah. Match. We are done. fi # a: If the md5sum of the dest file is the same as lastsum, replace the # destfile, saying we are replacing old config files if [ "$destsum" = "$lastsum" ]; then if [ "X$force_conffold" = "X" ]; then echo >&2 "Replacing config file $dest_file with new version" replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi else # b: If the md5sum of the dest file differs from lastsum, we need to ask # the user what action to take. if [ "X$force_conffnew" != "X" ]; then echo >&2 "Replacing config file $dest_file with new version" echo >&2 "since you asked for it." if [ "$destsum" = "$newsum" ]; then echo >&2 "The new and the old files are identical, AFAICS" else echo >&2 "The new and the old files are different" fi replace_conf_file; exit 0; fi if [ "X$force_conffold" != "X" ]; then replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi # c: If the destination file is the same as the new maintianer provided one, # we need do nothing. if [ "$newsum" = "$destsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums of the file in place matches, nothing needs be done." fi replace_md5sum; exit 0; # Hah. Match. We are done. fi done='NO'; while [ "X$done" = "XNO" ]; do if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then # Use debconf to prompt. if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then templ=ucf/changeprompt_threeway else templ=ucf/changeprompt fi if [ "X$override_template" != "X" ]; then choices="$(db_metaget $templ Choices-C)" choices2="$(db_metaget $override_template Choices-C)" if [ "$choices" = "$choices2" ]; then templ=$override_template fi fi db_fset "$templ" seen false db_reset "$templ" db_subst "$templ" FILE "$dest_file" db_subst "$templ" NEW "$new_file" db_subst "$templ" BASENAME "$(basename $dest_file)" db_input critical "$templ" || true if ! db_go; then # The current ucf interface does not provide a way for it # to tell its caller that the user chose to back up. # However, we could get here, if the caller turned on # debconf's backup capb. The best thing to do seems to be # to ignore requests to back up. continue fi db_get "$templ" ANSWER="$RET" else echo >&2 "Need debconf to interact" exit 2 ######################################################################################## # # Prompt without using debconf. # # cat >&2 <<EOPRMT # # Configuration file \`$dest_file' # # ==> File on system created by you or by a script. # # ==> File also in package provided by package maintainer. # # What would you like to do about it ? Your options are: # # Y or I : install the package maintainer's version # # N or O : keep your currently-installed version # # D : show the differences between the versions # # S : show the side-by-side differences between the versions # # EOPRMT # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # cat >&2 <<EOTD # # 3 or T : show a three way difference between current, older, # # and new versions of the file # # M : Do a 3 way merge between current, older, # # and new versions of the file [Very Experimental] # # EOTD # # fi # # cat >&2 <<EOPEND # # Z : start a new shell to examine the situation # # The default action is to keep your current version. # # EOPEND # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/3/T/M/Z) [default=N] ?" # # else # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/Z) [default=N] ?" # # fi # # read -e ANSWER </dev/tty # ######################################################################################## fi case "$ANSWER" in install_new|y|Y|I|i) echo >&2 "Replacing config file $dest_file with new version" RETAIN_OLD=YES replace_conf_file; exit 0; ;; diff|D|d) DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" ;; sdiff|S|s) DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")" show_diff "$DIFF" ;; diff_threeway|3|t|T) if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then if [ -e "$dest_file" ]; then DIFF="$(diff3 -L Current -L Older -L New -A \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file")" || true else DIFF="$(diff3 -L Current -L Older -L New -A \ /dev/null "$statedir/cache/$cached_file" \ "$new_file")" || true fi show_diff "$DIFF" else DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" fi ;; merge_threeway|M|m) echo >&2 "Merging changes into the new version" if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then ret=0 diff3 -L Current -L Older -L New -m \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$? case "$ret" in 0) new_file="$dest_file.${NEW_SUFFIX}" RETAIN_OLD=YES replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 ;; *) mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}" db_subst ucf/conflicts_found dest_file "$dest_file" db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}" db_input critical ucf/conflicts_found || true db_go || true ;; esac else replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 fi ;; shell|Z|z) # We explicitly connect STDIN and STDOUT to the # script's controlling terminal, so even if STDIN is # fed by a pipe, as is the case when run from # /usr/bin/debconf, the shell should be fully # functional. However, the test for a controlling # terminal uses /usr/bin/tty, which consults only # STDIN. As far as I can tell, when run from debconf, # ucf will _never_ use the current terminal. If the # goal is to check for access to a terminal, the test # should be for foreground process group membership, # not a terminal connected to STDIN (tty -s), and not # a terminal it doesn't necessarily own (tty -s # </dev/tty). The easiest way do this from a shell is # probably with /bin/ps. if ps -o stat= --ppid $$ | grep -q '+'; then export UCF_CONFFILE_OLD="$dest_file" export UCF_CONFFILE_NEW="$new_file" bash >/dev/tty </dev/tty || true elif [ -n "$DISPLAY" ]; then x-terminal-emulator || true else # Don't know what to do echo >&2 "No terminal, and no DISPLAY set, can't fork shell." sleep 3; fi ;; keep_current|n|N|o|O|'') replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; ;; *) if [ "$DEBCONF_OK" = "YES" ]; then echo "Error: unknown response from debconf:'$RET'" >&2 exit 1 else echo echo "Please answer with one of the single letters listed." >&2 echo fi esac done fi db_stop exit 0;
Close